#!/usr/bin/python
#-*- coding: utf-8 -*-

import sys,time
import urllib2

H=20 #velikost hraci plochy
POHYBU=9
VELIKOST_NABIDKY=8
VELIKOST_ENTRY=10
PREKLAD={0:"nahoru",1:"doprava",2:"dolu",3:"doleva"}
DIRS={"N":0,"R":1,"D":2,"L":3}
DIRS2={"^":0,">":1,"v":2,"<":3}
D=[(-1,0),(0,1),(1,0),(0,-1)]
KROK=1
CILX=0
CILY=0
V=[]
DONE=False

OK=0
VYHRAL=1
PROHRAL=2

RUNNING=False
ID=0
MAPA=[]
LX=0
LY=0
LDIR=""
POHYBY=""

def get(adresa):
  global ID,MAPA,POHYBY,LX,LY,LDIR
  try: stream=urllib2.urlopen(adresa)
  except urllib2.HTTPError:
    print "\nNepodařilo se připojit k zadabému serveru, proto byl program ukončen\n"
    sys.exit()
  radek=stream.readline()
  try: ID=int(radek)
  except ValueError:
    print radek
    return 0
  data=stream.readlines()
  MAPA=data[:H]
  for i in range(len(MAPA)): MAPA[i]=list(MAPA[i].strip())
  LX=int(data[-2].split()[1])-1
  LY=int(data[-2].split()[0])-1
  LDIR=DIRS[data[-2].split()[2]]
  POHYBY=data[-1].strip()
  global DONE,CILX,CILY
  if(not DONE):
    for i in range(H):
      V.append([])
      for j in range(H):
        V[-1].append(10**9)
        if(MAPA[i][j]=="$"):
          CILX=i
  	  CILY=j
    V[CILX][CILY]=0
    dfs(CILX,CILY)
    DONE=True
  #  for i in V: print i
  get("http://%s:%d/kolo?id=%d&pohyby=%s"%(ADRESA,PORT,ID,step()))

def dfs(x,y):
  for dx in (-1,0,1):
    for dy in (-1,0,1):
      if(dx*dx+dy*dy==1):
        nx=x+dx
	ny=y+dy
        if(nx<0 or ny<0 or nx>=H or ny>=H): continue
	if(MAPA[nx][ny] in "X#"): continue
	if(V[nx][ny]>V[x][y]+1):
	  V[nx][ny]=V[x][y]+1
	  dfs(nx,ny)

def newgame():
  get("http://%s:%d/start"%(ADRESA,PORT))
def jed(x,y):
  if(x<0 or y<0 or x>=H or y>=H): return PROHRAL
  if(MAPA[x][y]=="X"): return -1
  if(MAPA[x][y]=="."): return 0
  if(MAPA[x][y]=="#"): return PROHRAL
  if(MAPA[x][y]=="$"): return VYHRAL

def simulate(s,kroky=False):
  global LX,LY,LDIR
  x=LX
  y=LY
  d=LDIR
  k=1
  for i in s:
    d%=4
    if(i=="L"): d+=3
    elif(i=="R"): d+=1
    elif(i=="Z"):
      odpoved=jed(x-D[d][0],y-D[d][1])
      if(odpoved>0): return -1,odpoved
      if(odpoved==0): x,y=x-D[d][0],y-D[d][1]
    else:
      for j in range(ord(i)-ord("0")):
        odpoved=jed(x+D[d][0],y+D[d][1])
        if(odpoved>0): return -1,odpoved
        if(odpoved==0): x,y=x+D[d][0],y+D[d][1]
  if(MAPA[x][y] in DIRS2.keys()):
    d2=DIRS2[MAPA[x][y]]
    odpoved=jed(x+D[d2][0],y+D[d2][1])
    if(odpoved>0): return -1,odpoved
    if(odpoved==0): x,y=x+D[d2][0],y+D[d2][1]
  return x,y,d%4

VYSLEDEK=""
Q=-1
def generuj(a):
  global Q,VYSLEDEK
  if(len(a)==5):
    s=""
    for i in a: s+=POHYBY[i]
    res=simulate(s)
    if(res[0]==-1):
      if(res[1]==PROHRAL): q=0
      else: q=10**9
    else:
      q=10**6-V[res[0]][res[1]] 
    if(q>Q):
      Q=q
      VYSLEDEK=s+""
  for i in range(9):
    if(i not in a): generuj(a+[i])

def step():
  global Q,VYSLEDEK
  Q=-1
  VYSLEDEK=""
  generuj([])
  print VYSLEDEK
  return VYSLEDEK

def usage():
  print "\nPoužití: %s adresa port\n"%(sys.argv[0])
  sys.exit()


try:
  ADRESA=sys.argv[1]
  PORT=int(sys.argv[2])
except: usage()

newgame()
