#!/usr/bin/python
#-*- coding: utf-8 -*-

import sys,time
import urllib2
from Tkinter import *
from tkMessageBox import *
import tkSimpleDialog

H=20 #velikost hraci plochy
POHYBU=9
START="Pro start nové hry zmačkněte tlačítko Nová hra"
NABIDKA="V tomto tahu máte k dispozici tyto pohyby:"
VELIKOST_NABIDKY=8
VELIKOST_ENTRY=10
PREKLAD={0:"nahoru",1:"doprava",2:"dolu",3:"doleva"}
DIRS={"N":0,"R":1,"D":2,"L":3}
DIRS2={"^":0,">":1,"v":2,"<":3}
D=[(-1,0),(0,1),(1,0),(0,-1)]
KROK=1

OK=0
VYHRAL=1
PROHRAL=2

RUNNING=False
ID=0
MAPA=[]
LX=0
LY=0
LDIR=""
POHYBY=""

class ButtonHandler:
  def generuj(self,a,x,y,d):
    if(len(a)==5):
      s=""
      for i in a: s+=POHYBY[i]
      if(simulate(s)==(x,y,d)): self.VYSLEDEK=s+""
    else:
      for i in range(9):
        if(i not in a): self.generuj(a+[i],x,y,d)
      
  def __init__(self,x,y):
    self.x=x
    self.y=y
  def __call__(self,*args):
    if(not RUNNING): return 0
    d=tkSimpleDialog.askstring("Cesta","Pokusím se najít cestu na toto políčko. Zadejte směr, kterým chcete mít robota otočeného (N,R,D,L nebo X=je mi to jedno)")
    if(d!="X" and d not in DIRS.keys()):
      showerror("Smůla","Takový směr bohužel neznám.")
      return -1
    self.VYSLEDEK=""
    end=False
    if(MAPA[self.x][self.y]=="$"):
      end=True
      MAPA[self.x][self.y]="."
    if(d=="X"):
      for d in DIRS.keys():
        self.generuj([],self.x,self.y,DIRS[d])
    else:
      self.generuj([],self.x,self.y,DIRS[d])
    if(end): MAPA[self.x][self.y]="$"
    if(self.VYSLEDEK!=""):
      showinfo("Hurá","Nalezl jsem požadovanou cestu, vkládám ji do vstupního boxu.")
      vstup.delete(0,END)
      vstup.insert(0,self.VYSLEDEK)
    else: showinfo("Bohužel","Bohužel jsem žádnou takovou cestu nenašel")


class PohybHandler:
  def __init__(self,id):
    self.id=id
    self.zmacle=False
  def __call__(self,*args):
    if(RUNNING):
      vstup.insert(END,POHYBY[self.id])
      self.zmackle= not self.zmackle;

out=[]
def refresh():
  x=out[0][0]
  y=out[0][1]
  d=out[0][2]
  del out[0]
  for i in range(H):
    for j in range(H):
      plocha[i][j].config(text=MAPA[i][j])
      plocha[i][j].config(bg="white")
  for i in range(POHYBU): 
    pohyby[i].config(text=POHYBY[i])
    handlery[i].zmackle=False
    pohyby[i].config(bg="white",activebackground="white")
  plocha[x][y].config(bg="green")
  status.config(text="Robot Lerak je na zeleném políčku a je natočen %s. Vyberte mu příkazy a potvrťe tah."%PREKLAD[d])

def get(adresa):
  global ID,MAPA,POHYBY,LX,LY,LDIR
  try: stream=urllib2.urlopen(adresa)
  except urllib2.HTTPError:
    print "\nNepodařilo se připojit k zadanému serveru, proto byl program ukončen\n"
    sys.exit()
  radek=stream.readline()
  try: ID=int(radek)
  except ValueError:
    showinfo("Konec hry",radek)
    answer=askyesno("Znova","Chcete hrát novou hru?")
    if(answer): newgame()
    else: sys.exit()
    return 0
  data=stream.readlines()
  MAPA=data[:H]
  for i in range(len(MAPA)): MAPA[i]=list(MAPA[i].strip())
  LX=int(data[-2].split()[1])-1
  LY=int(data[-2].split()[0])-1
  LDIR=DIRS[data[-2].split()[2]]
  POHYBY=data[-1].strip()
  vstup.delete(0,END)

def newgame():
  global RUNNING
  get("http://%s:%d/start"%(ADRESA,PORT))
  out.append((LX,LY,LDIR))
  refresh()
  RUNNING=True

def jed(x,y):
  if(x<0 or y<0 or x>=H or y>=H): return PROHRAL
  if(MAPA[x][y]=="X"): return -1
  if(MAPA[x][y]=="."): return 0
  if(MAPA[x][y]=="#"): return PROHRAL
  if(MAPA[x][y]=="$"): return VYHRAL

def simulate(s,kroky=False):
  global LX,LY,LDIR
  x=LX
  y=LY
  d=LDIR
  k=1
  for i in s:
    d%=4
    if(i=="L"): d+=3
    elif(i=="R"): d+=1
    elif(i=="Z"):
      odpoved=jed(x-D[d][0],y-D[d][1])
      if(odpoved>0): return -1,odpoved
      if(odpoved==0): x,y=x-D[d][0],y-D[d][1]
    else:
      for j in range(ord(i)-ord("0")):
        odpoved=jed(x+D[d][0],y+D[d][1])
        if(odpoved>0): return -1,odpoved
        if(odpoved==0): x,y=x+D[d][0],y+D[d][1]
    if(kroky):
      out.append((x,y,d%4))
      okno.after(k*KROK*1000,refresh)
      k+=1
  if(MAPA[x][y] in DIRS2.keys()):
    d2=DIRS2[MAPA[x][y]]
    odpoved=jed(x+D[d2][0],y+D[d2][1])
    if(odpoved>0): return -1,odpoved
    if(odpoved==0): x,y=x+D[d2][0],y+D[d2][1]
  return x,y,d%4
  
def jetook(s,pohyby):
  if(len(s)>5): return False
  p=list(pohyby)
  for i in s:
    ok=False
    for j in range(len(p)):
      if(p[j]==i):
        del p[j]
	ok=True
	break
    if not ok: return False
  return True

def jetook2(s,pohyby):
  if( not jetook(s,pohyby)): return False
  if(len(s)==5): return True
  if(simulate(s)==(-1,VYHRAL)): return True
  return False

def where():
  s=vstup.get()
  if(not jetook(s,POHYBY)):
    showerror("Chyba","Zadaný popis tahů neni validní")
    return -1
  vysledek=simulate(s)
  if(vysledek[0]==-1):
    if vysledek[1]==VYHRAL: showinfo("Vyhra","Robot by touto posloupností tahu došel k pokladu")
    else: showinfo("Prohra","Robot by touto posloupností tahů prohrál")
  else:
    status.config(text="Robot by touto posloupností tahů došel na červené políčko natočen %s"%PREKLAD[vysledek[2]])
    out.append((LX,LY,LDIR))
    refresh()
    plocha[vysledek[0]][vysledek[1]].config(bg="red")
 
def go():
  s=vstup.get()
  if(jetook2(s,POHYBY)):
    if(KROKY): simulate(s,True)
    get("http://%s:%d/kolo?id=%d&pohyby=%s"%(ADRESA,PORT,ID,s))
    out.append((LX,LY,LDIR))
    if(KROKY): okno.after(5*KROKY*1000,refresh)
    else: refresh()
  else: showerror("Chyba","Zadaný popis tahů neni validní")

def usage():
  print "\nPoužití: %s adresa port\n"%(sys.argv[0])
  sys.exit()

try:
  ADRESA=sys.argv[1]
  PORT=int(sys.argv[2])
except: usage()

okno=Tk()
okno.title("RoboRace")
plocha=[]
for i in range(H):
  plocha.append([])
  for j in range(H):
    h=ButtonHandler(i,j)
    plocha[-1].append(Button(okno,width=1,height=1,command=h))
    plocha[-1][-1].grid(row=i,column=j)

status=Label(okno,text=START)
status.grid(row=H,column=0,columnspan=H)

nabidka=Label(okno,text=NABIDKA)
nabidka.grid(row=H+1,column=0,columnspan=VELIKOST_NABIDKY,sticky=W+E+N+S)

pohyby=[]
handlery=[]
for i in range(POHYBU):
  handlery.append(PohybHandler(i))
  pohyby.append(Button(okno,width=1,height=1,command=handlery[-1]))
  pohyby[-1].grid(row=H+1,column=VELIKOST_NABIDKY+i+1)


KROKY=True
def zmen_kroky():
  global KROKY
  KROKY=not KROKY
  kroky.config(text={False:"Nezobrazují se kroky",True:"Zobrazují se kroky"}[KROKY])
kroky=Button(okno, text="Zobrazují se kroky",command=zmen_kroky)
kroky.grid(row=H+2,column=0,columnspan=VELIKOST_NABIDKY,sticky=W+E+N+S)

vstup=Entry(okno)
vstup.grid(row=H+2,column=VELIKOST_NABIDKY+1,columnspan=POHYBU,sticky=W+E+N+S)

new=Button(okno,text="Nová hra",command=newgame)
new.grid(row=H+3,column=0,columnspan=H/4,sticky=W+E+N+S)

kdebyskoncil=Button(okno,text="Kde by skončil?",command=where)
kdebyskoncil.grid(row=H+3,column=H/4,columnspan=H/4,sticky=W+E+N+S)

udelejtah=Button(okno,text="Dokončit tah",command=go)
udelejtah.grid(row=H+3,column=2*H/4,columnspan=H/4,sticky=W+E+N+S)

end=Button(okno,text="Konec hry",command=sys.exit)
end.grid(row=H+3,column=3*H/4,columnspan=H/4,sticky=W+E+N+S)

okno.mainloop()

